var exifasr_directorySeparator = null;

function startDisplay() {
	var fileName;
	var sb = document.getElementById('statusbar');
	var pb = document.getElementById('progressbar');
	if (pb)  pb.setAttribute('mode', 'undetermined');
	clearTexts('outputDiv');
	if (document.getElementById('remote_file').value != '') {
		if (sb)  sb.setAttribute('label', getPString('processingRemoteURL')); 
		fileName = document.getElementById('remote_file').value;
	} else {
		if (sb)  sb.setAttribute('label', getPString('processingLocalFile')); 
		fileName = document.getElementById('local_file').value;
	}

	if (fileName.indexOf('file://') == 0) {
		if (!exifasr_directorySeparator)  setExifDirectorySeparator();
		var re1 = new RegExp('^file://(localhost|127.0.0.1)?', '')
		var re2 = new RegExp('/', 'g'); 
		var re3 = new RegExp('^/([a-zA-Z]:)', ''); 
		fileName = unescape(fileName.replace(re1, '').replace(re3, '$1').replace(re2, exifasr_directorySeparator));
	}
	
	try {
		processFile(fileName, null, 'outputDiv', !document.getElementById('maker').checked, document.getElementById('image').checked, document.getElementById('basic').checked);
	} catch (e) {
//		var output = new Array();
//		for (var a in e) {
//			output.push(a + ': ' + e[a]);
//		}
//		alert(e + '\n' + output.join('\n'));
		var handled = false;
		if (e.name == 'NS_ERROR_FAILURE'  &&  e.location) {
			var location = e.location.toString();
			if (location.indexOf('read8') != -1) {
				alert(getPString('networkError'));
				handled = true;
			} else if (location.indexOf('readByteURLMoz') != -1) {
				alert(getPString('connectionError'));
				handled = true;
			}
		} 
		if (!handled) {
			alert(getPString('errorNotification'));
			var message = '' 
					+ (e.result			? 'Result:        ' + '0x' + e.result.toString(16) + '\n' : '')
					+ (e.name			? 'Name:          ' + e.name + '\n' : '')
					+ (e.message		? 'Message:       ' + e.message + '\n' : '')
					+ (e.fileName		? 'File name:     ' + e.fileName + '\n' : '')
					+ (e.filename		? 'File name:     ' + e.filename + '\n' : '')
					+ (e.lineNumber		? 'Line number:   ' + e.lineNumber + '\n' : '')
					+ (e.linenumber		? 'Line number:   ' + e.linenumber + '\n' : '')
					+ (e.columnNumber	? 'Column number: ' + e.columnNumber + '\n' : '')
					+ (e.columnnumber	? 'Column number: ' + e.columnnumber + '\n' : '')
					+ (e.location		? 'Location:      ' + e.location + '\n' : '')
					+ (e.data			? 'Data:          ' + e.data + '\n' : '')
					+ (e.inner			? 'Inner:         ' + e.inner + '\n' : '')
					+ (e.stack			? 'Stack:         ' + e.stack + '\n' : '');
			if (confirm(message + '\n' + getPString('copyToClipboard'))) {
				copyToClipboard(message);
			}
		} 
	}
//	resizeOutputDiv()
	if (sb)  sb.setAttribute('label', getPString('done')); 
	if (pb)  pb.setAttribute('mode', 'determined');
	if (pb)  pb.setAttribute('value', '0');
}	// startDisplay()

function resizeOutputDiv() {	// needed for FF3?
	var ele = document.getElementById('outputDiv');
	ele.style.display = 'none';
	var tmp = ele.offsetTop;
	var tmp2 = window.innerHeight;
	ele.style.height = (tmp2 - tmp - 45) + 'px';
	ele.style.display = 'block';
//	alert(tmp + '\n' + tmp2 + '\n' + ele.style.height);
}     // resizeOutputDiv()

//window.onresize = resizeOutputDiv;

function pickFile() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
				.createInstance(nsIFilePicker);
	fp.init(window, getPString('selectFile'), nsIFilePicker.modeOpen);
	fp.appendFilter(getPString('jpegFiles'), getPString('jpegExtensions'));
	fp.appendFilters(nsIFilePicker.filterImages);
//	fp.appendFilters(nsIFilePicker.filterHTML | nsIFilePicker.filterImages | nsIFilePicker.filterText | nsIFilePicker.filterAll);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK) {
		var thefile = fp.file;
  		document.getElementById('local_file').value = thefile.path;
		clearText('fileDiv');
		displayText(cleanExifStringData(thefile.path), 'fileDiv');
		saveURL();
		clearURL();
//		disableMainButton(false);
	}
}	// pickFile()

/*
function printOutput() {
	var frame = document.getElementById("outputDiv");
	var req = frame.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
	var wbprint = req.getInterface(Components.interfaces.nsIWebBrowserPrint);
	var settings = PrintUtils.getPrintSettings(); // from chrome://global/content/printUtils.js
	wbprint.print(settings, null);
}	// printOutput()
*/

function copyToClipboard(text) {
	var gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
							.getService(Components.interfaces.nsIClipboardHelper);
	gClipboardHelper.copyString(text.replace(/<html:/gi, '<').replace(/<\/html:/gi, '</').replace(/ xmlns:html="http:\/\/www.w3.org\/1999\/xhtml"/g, ''));
}	// copyToClipboard()

function handleLocalChanged(value) {
	clearText('fileDiv');
	displayText(cleanExifStringData(value), 'fileDiv');
	saveURL();
	clearURL();
//	disableMainButton(false);
}	// handleLocalChanged()

function handleRemoteChanged(value) {
	clearText('fileDiv');
	displayText(cleanExifStringData(value), 'fileDiv');
	clearFile();
//	disableMainButton(false);
}	// handleRemoteChanged()

var exifasr_savedURL = document.getElementById('remote_file').value;

function saveURL() {
	var s = document.getElementById('remote_file').value;
	if (s != '')  exifasr_savedURL = s;
}	// saveURL()

function restoreURL() {
	document.getElementById('remote_file').value = exifasr_savedURL;
	clearFile();
	clearText('fileDiv');
	displayText(cleanExifStringData(exifasr_savedURL), 'fileDiv');
}	// restoreURL()

function clearURL() {
	document.getElementById('remote_file').value = '';
}	// clearURL()

function clearFile() {
	document.getElementById('local_file').value = '';
}	// clearFile()

function _handleExifImagePicked(url) {
	if (url.indexOf('file://') == 0) {
		if (!exifasr_directorySeparator)  setExifDirectorySeparator();
		var re1 = new RegExp('^file://(localhost|127.0.0.1)?', '')
		var re2 = new RegExp('/', 'g'); 
		var re3 = new RegExp('^/([a-zA-Z]:)', ''); 
		url = unescape(url.replace(re1, '').replace(re3, '$1').replace(re2, exifasr_directorySeparator));
		document.getElementById('local_file').value = url;
		clearURL();
	} else {
		saveURL();
		document.getElementById('remote_file').value = url;
		clearFile();
	}
	clearText('fileDiv');
	displayText(cleanExifStringData(url), 'fileDiv');
	startDisplay();
}	// _handleExifImagePicked()

function exifViewDiv(checked, divExt) {
	var div = document.getElementById('outputDiv_' + divExt);
	if (div)  div.style.display = (checked ? 'none' : '');
}	// exifViewDiv()

function setExifDirectorySeparator() {
	try {
		const id = 'exif_viewer@mozilla.doslash.org';
		var ext = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					.getInstallLocation(id)
					.getItemLocation(id); 
		// ext is an instance of nsIFile, so ext.path contains the directory as a string

		// determine the file-separator
		if (ext.path.search(/\\/) != -1) {
			exifasr_directorySeparator = '\\';		// Windows
		} else if (ext.path.search(/\//) != -1) {
			exifasr_directorySeparator = '/';		// Unix
		} else {
			exifasr_directorySeparator = ':';		// Mac
		}
	} catch (e) {
		exifasr_directorySeparator = '\\';
	}
}	// setExifDirectorySeparator()

function setFontSize(n) {
	var sizes = new Array('66%', '83%', '100%', '120%', '150%');
	var o = document.getElementById('outputDiv');
	if (!o  ||  !o.style  ||  n < 0  ||  n >= sizes.length)  return;
	o.style.overflow = 'hidden';
	o.style.fontSize = sizes[n];
	setTimeout("document.getElementById('outputDiv').style.overflow = 'scroll';", 2);
}	// setFontSize()

function setRelativeFontSize(t) {
	var o = document.getElementById('outputDiv');
	var factor = 1.10;
	if (!o  ||  !o.style)  return;
	var x = parseInt(o.style.fontSize, 10);
	switch (t) {
		case '+':
			x = Math.round(x * factor);
			break;
		case '-':
			x = Math.round(x / factor);
			break;
		default:
			break;
	}
	
	o.style.overflow = 'hidden';
	o.style.fontSize = x + '%';
	setTimeout("document.getElementById('outputDiv').style.overflow = 'scroll';", 2);
}	// setRelativeFontSize()

var asrexif_strbundle = document.getElementById("strings");

function getPString(key) {
	try {
		return asrexif_strbundle.getString(key);
	} catch (e) {
		return key;
	}
}	// getPString()

function getFormattedPString(key, inserts) {
	try {
		return asrexif_strbundle.getFormattedString(key, inserts);
	} catch (e) {
		return key + ' [' + inserts.join(' / ') + ']';
	}
}	// getFormattedPString()

/*
function showLocale() {
	var ps_cls = Components.classes["@mozilla.org/preferences-service;1"];
	var ps = ps_cls.getService(Components.interfaces.nsIPrefService);
	var branch = ps.getBranch('general.useragent.');
	alert('Locale is: ' + branch.getCharPref('locale'));
//	branch.setCharPref('locale', 'fr')
//	alert(branch.getCharPref('locale'));

	var strbundle = document.getElementById("strings");
	var test1 = strbundle.getString("testString");
	var test2 = strbundle.getFormattedString("testString2", [ 'end', 'start' ]);
	alert('String bundle test:\n\n' + test1 + '\n' + test2);
}	// showLocale()
*/

// from Mozilla/Firefox's broswser.js
function toJavaScriptConsole() {
	toOpenWindowByType("global:console", "chrome://global/content/console.xul");
}	// toJavaScriptConsole()

function toOpenWindowByType(inType, uri, features) {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow(inType);

	if (topWindow) {
		topWindow.focus();
		return topWindow;
	} else if (features) {
		return window.open(uri, "_blank", features);
	} else {
		return window.open(uri, "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
	}
}	// toOpenWindowByType()

function showReleaseNotes() {
	toOpenWindowByType("exif:notes", "chrome://exif/content/notes.xul");
}	// showReleaseNotes()

function exifScrollTo(eleID) {
	var ele = document.getElementById(eleID);
	if (ele  &&  ele.scrollIntoView) ele.scrollIntoView();
}	// exifScrollTo()

function exifPageUpDown(u_or_d) {
	var ele = document.getElementById('outputDiv');
	var t = ele.scrollTop + (u_or_d == 'u' ? -ele.clientHeight : +ele.clientHeight);
	if (t < 0) {
		t = 0;
	} else if (t >= ele.scrollHeight) {
		t = ele.scrollHeight - 1;
	}
	ele.scrollTop = t;
}	// exifPageUpDown()

function exifLineUpDown(u_or_d) {	// messes up the scroll bar
	var ele = document.getElementById('outputDiv');
	var t = ele.scrollTop + (u_or_d == 'u' ? -10 : +10);
	if (t < 0) {
		t = 0;
	} else if (t >= ele.scrollHeight) {
		t = ele.scrollHeight - 1;
	}
	ele.scrollTop = t;
}	// exifLineUpDown()

function saveExifAsImage() {
	toOpenWindowByType('exif:capture', 'chrome://exif/content/capture.xul');
}	// saveExifAsImage()

function simplePrint() {
	try {
		var win = window.open('empty.html', "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
	} catch (e) {
		alert(getPString('simplePrintError'));
		return;
	}
	self.focus();
/**/
	var out = [];
	out.push('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"  "http://www.w3.org/TR/html4/strict.dtd">');
	out.push('<html><head><title>Exif Image Metadata<\/title>');
	out.push('<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">');
	out.push('<style type="text/css">');
	out.push('body { font-family: serif; font-size: 100%; }');
	out.push('.no_print { display: none; }');
	out.push('<\/style>');
	out.push('<base href="chrome://exif/content/">');
	out.push('<\/head><body>');
	out.push(document.getElementById('outputDiv').innerHTML.replace(/html:/gi, ''));
	out.push('<\/body><\/html>');

	win.document.open();
	win.document.write(out.join('\r\n'));
	win.document.close();
	win.print();
	win.close();
/**/
}	// simplePrint()

function copyKMLtoClipboard() {
	copyToClipboard(exifasr_kml);
	alert(getPString('copyKMLtoClipboardResponse'));
}	// copyKMLtoClipboard()

function saveKMLtoFile(launch) {
/*	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to create a file has been denied by your security settings.");
		return;
	}*/
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
				.createInstance(nsIFilePicker);
	fp.init(window, getPString('selectFile'), nsIFilePicker.modeSave);
	fp.appendFilter(getPString('kmlFiles'), getPString('kmlExtensions'));
	fp.defaultExtension = 'kml';
	fp.defaultString = exifasr_fileName.match(/(\w*)\.(\w*)$/)[1];	// use the image filename as the default KML filename
//	fp.appendFilters(nsIFilePicker.filterHTML | nsIFilePicker.filterImages | nsIFilePicker.filterText | nsIFilePicker.filterAll);
	var res = fp.show();
	if (res != nsIFilePicker.returnCancel) {
		var savefile = fp.file;
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(savefile.path);
		if (file.exists() == false) {
			file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
		}
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
							.createInstance( Components.interfaces.nsIFileOutputStream );
		outputStream.init(file, 0x02 | 0x08 | 0x20, 420, 0 );	// (write-only | create-file | truncate)
		var result = outputStream.write(exifasr_kml, exifasr_kml.length );
		outputStream.close();
		if (launch)  file.launch();		// open file in Google Earth!?!
		alert(getPString('saveKMLtoFileResponse') + ' ' + savefile.path);
	}
}	// saveKMLtoFile()

function launchKML() {
	if (exifasr_directorySeparator == null) {
		setExifDirectorySeparator();
	}
	var tempDir = Components.classes['@mozilla.org/file/directory_service;1']
       	         .getService(Components.interfaces.nsIProperties)
          	     .get('TmpD', Components.interfaces.nsIFile);
	var file = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(tempDir.path + exifasr_directorySeparator + 'exif.kml');
	if (file.exists() == false) {
		file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
	}
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
						.createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init(file, 0x02 | 0x08 | 0x20, 420, 0 );	// (write-only | create-file | truncate)
	var result = outputStream.write(exifasr_kml, exifasr_kml.length );
	outputStream.close();
	file.launch();		// open file in Google Earth!?!
}	// launchKML()

window.onresize = fixDiv;
window.onload = fixDiv;

function fixDiv() {
	fixDivs('outputDiv');
}	// fixDiv()

function fixDivs(divName) {
	var version = getAppVersion();
	if (/^[12]\.*/.test(version))  return;	// the following code is only needed for FF 3

//	for some reason, in FF3 the outer div tries to display the full content within 
//	it, by widening indefinitely and and lengthening to cover the status bar;
//	hence, we need to manually adjust the widths of the inner divs and the height
//	of the outer div

//	step 1: adjust inner widths

	var subdivs = ['iptc', 'iptc_core', 'ifd0', 'ifd1', 'iop', 'gps', 'subifd', 'mn'];	// 'head', 'msg'
	for (var i = 0 ; i < subdivs.length ; i++) {
		var div = document.getElementById(divName + '_' + subdivs[i]);
		if (div) {
			div.style.width = (window.innerWidth - 35) + 'px';
			div.style.overflow = 'auto';
		}
	}

//	step 2: adjust outer height

	var win_h = window.innerHeight;
	var div = document.getElementById(divName);
	if (div) {
		var div_t = div.offsetTop;
		var sb_h = 40;		// height of statusbar
		var h = win_h - div_t - sb_h; 
		if (h >= 0)  div.style.height = h + 'px';
	}
}	// fixDivs()

function disableMainButton(t_or_f, fileName) {
/*
	if (t_or_f) {
		var cache = Components.classes["@mozilla.org/network/cache-service;1"]
            			.getService(Components.interfaces.nsICacheService);
		var id = 'test';
		var storagePolicy = cache.STORE_ANYWHERE;
		var streamBased = cache.STREAM_BASED;
		var session = cache.createSession(id, storagePolicy, streamBased);
		var accessRequested = cache.ACCESS_READ;
		var blockingMode = cache.NON_BLOCKING;
		try {
			var entry = session.openCacheEntry(fileName, accessRequested, blockingMode);
		} catch (e) {
			alert('failure');
			return;
		}
		entry.doom();
	}
	return;
/**/
	var btn = document.getElementById('mainBtn');
	if (btn) {
		btn.disabled = t_or_f;
	}
}	// disableMainButton()

function getAppVersion() {
	var info = Components.classes["@mozilla.org/xre/app-info;1"]
						.getService(Components.interfaces.nsIXULAppInfo);
	// info.name: "Firefox"
	// info.version: "2.0.0.1"
	// info.ID: "{ex8040...}"
	// info.appBuildID: "2007112718"
	// info.platformBuildID: "2007112718"
	// info.platformVersion: "1.8.1.11"
	// info.vendor: "Mozilla"
	return info.version;
}	// getAppVersion()

function getExtensionVersion() {
	var extmgr = Components.classes["@mozilla.org/extensions/manager;1"]
						.getService(Components.interfaces.nsIExtensionManager);
	var addon = extmgr.getItemForID("exif_viewer@mozilla.doslash.org");
	// addon.iconURL: "chrome:/mozapps/skin/xpinstall/xpinstallItemGeneric.png"
	// addon.id: "exif_viewer@mozilla.doslash.org"
	// addon.installLocationKey: "app-profile"
	// addon.maxAppVersion: "2.0.0.*"
	// addon.minAppVersion: "1.5"
	// addon.name: "Exif Viewer"
	// addon.type
	// var interpretedType = '?';
	// if (addon.type == 1)  interpretedType = 'app';
	// if (addon.type == 2)  interpretedType = 'extension';  
	// if (addon.type == 4)  interpretedType = 'theme';  
	// if (addon.type == 8)  interpretedType = 'locale';  
	// if (addon.type == 16)  interpretedType = 'plugin';  
	// if (addon.type == 32)  interpretedType = 'multi xpi';  
	// addon.updateRDF: ""
	// addon.version: "1.36"
	// addon.xpiHash: ""
	// addon.xpiURL: "none"
	return addon.version;
}	// getExtensionVersion() 